import sys
import subprocess

from PyICU import Locale as PyICULocale


def get_locale_name_pyicu(code):
    locale = PyICULocale(code)
    return locale.getDisplayName(locale)

def read_all_codes():
    fdp = subprocess.Popen(['locale', '-a'], stdout=subprocess.PIPE)
    lines = fdp.stdout.read().split('\n')
    codes = []

    for line in lines:
        if line.endswith('utf8'):
            codes.append(line)

    #FIXME: This is a temporary workaround for locales that are essential to
    # OLPC, but are not in Glibc yet.
    for code in ['ht_HT.utf8', 'fa_AF.utf8', 'ps_AF.utf8']:
        codes.append(code)

    return codes

if __name__ == '__main__':
    available_codes = read_all_codes()

    names_pyicu = {}
    for code in available_codes:
        locale_name = get_locale_name_pyicu(code)
        names_pyicu[code] = locale_name
